Subject: Re: [PATCH net-next] net/hanic: Add the hanic network interface for high availability links

From: Jakub Kicinski <[email-masked]>
Date: Mon, 21 Nov 2022 19:58:10 -0800

On Fri, 18 Nov 2022 15:26:39 -0800 Steve Williams wrote:
> This is a virtual device that implements support for 802.1cb R-TAGS
> and duplication and deduplication. The hanic nic itself is not a device,
> but enlists ethernet nics to act as parties in a high-availability
> link. Outbound packets are duplicated and tagged with R-TAGs, then
> set out the enlisted links. Inbound packets with R-TAGs have their
> R-TAGs removed, and duplicates are dropped to complete the link. The
> algorithm handles links being completely disconnected, sporadic packet
> loss, and out-of-order arrivals.
> 
> To the extent possible, the link is self-configuring: It detects and
> brings up streams as R-TAG'ed packets are detected, and creates streams
> for outbound packets unless explicitly filtered to skip tagging.

Superficially pattern matching on the standard - there has been 
a discussion about 802.1cb support in the HW offload context:

https://lore.kernel.org/netdev/[email-masked]/

Would be great if the two effort could align.